svn commit: r268162 - head/release/amd64

Nathan Whitehorn nwhitehorn at FreeBSD.org
Wed Jul 2 15:23:14 UTC 2014


Author: nwhitehorn
Date: Wed Jul  2 15:23:13 2014
New Revision: 268162
URL: http://svnweb.freebsd.org/changeset/base/268162

Log:
  Now that GENERIC can boot on UEFI systems (r268158), switch the build to use
  UEFI-compatible images. These will boot as before on BIOS systems, but will
  boot using the UEFI loader on UEFI-aware systems.

Replaced:
  head/release/amd64/make-memstick.sh
     - copied unchanged from r268161, head/release/amd64/make-uefi-memstick.sh
  head/release/amd64/mkisoimages.sh
     - copied unchanged from r268161, head/release/amd64/mkisoimages-uefi.sh
Deleted:
  head/release/amd64/make-uefi-memstick.sh
  head/release/amd64/mkisoimages-uefi.sh

Copied: head/release/amd64/make-memstick.sh (from r268161, head/release/amd64/make-uefi-memstick.sh)
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/release/amd64/make-memstick.sh	Wed Jul  2 15:23:13 2014	(r268162, copy of r268161, head/release/amd64/make-uefi-memstick.sh)
@@ -0,0 +1,41 @@
+#!/bin/sh
+#
+# This script generates a "memstick image" (image that can be copied to a
+# USB memory stick) from a directory tree.  Note that the script does not
+# clean up after itself very well for error conditions on purpose so the
+# problem can be diagnosed (full filesystem most likely but ...).
+#
+# Usage: make-memstick.sh <directory tree> <image filename>
+#
+# $FreeBSD$
+#
+
+PATH=/bin:/usr/bin:/sbin:/usr/sbin
+export PATH
+
+if [ $# -ne 2 ]; then
+	echo "make-memstick.sh /path/to/directory /path/to/image/file"
+	exit 1
+fi
+
+if [ ! -d ${1} ]; then
+	echo "${1} must be a directory"
+	exit 1
+fi
+
+if [ -e ${2} ]; then
+	echo "won't overwrite ${2}"
+	exit 1
+fi
+
+echo '/dev/ufs/FreeBSD_Install / ufs ro,noatime 1 1' > ${1}/etc/fstab
+makefs -B little -o label=FreeBSD_Install ${2}.part ${1}
+if [ $? -ne 0 ]; then
+	echo "makefs failed"
+	exit 1
+fi
+rm ${1}/etc/fstab
+
+mkimg -s gpt -b ${1}/boot/pmbr -p efi:=${1}/boot/boot1.efifat -p freebsd-boot:=${1}/boot/gptboot -p freebsd-ufs:=${2}.part -p freebsd-swap::1M -o ${2}
+rm ${2}.part
+

Copied: head/release/amd64/mkisoimages.sh (from r268161, head/release/amd64/mkisoimages-uefi.sh)
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/release/amd64/mkisoimages.sh	Wed Jul  2 15:23:13 2014	(r268162, copy of r268161, head/release/amd64/mkisoimages-uefi.sh)
@@ -0,0 +1,60 @@
+#!/bin/sh
+#
+# Module: mkisoimages.sh
+# Author: Jordan K Hubbard
+# Date:   22 June 2001
+#
+# $FreeBSD$
+#
+# This script is used by release/Makefile to build the (optional) ISO images
+# for a FreeBSD release.  It is considered architecture dependent since each
+# platform has a slightly unique way of making bootable CDs.  This script
+# is also allowed to generate any number of images since that is more of
+# publishing decision than anything else.
+#
+# Usage:
+#
+# mkisoimages.sh [-b] image-label image-name base-bits-dir [extra-bits-dir]
+#
+# Where -b is passed if the ISO image should be made "bootable" by
+# whatever standards this architecture supports (may be unsupported),
+# image-label is the ISO image label, image-name is the filename of the
+# resulting ISO image, base-bits-dir contains the image contents and
+# extra-bits-dir, if provided, contains additional files to be merged
+# into base-bits-dir as part of making the image.
+
+if [ "x$1" = "x-b" ]; then
+	# This is highly x86-centric and will be used directly below.
+	bootable="-o bootimage=i386;$4/boot/cdboot -o no-emul-boot"
+
+	# Make EFI system partition (should be done with makefs in the future)
+	dd if=/dev/zero of=efiboot.img bs=4k count=100
+	device=`mdconfig -a -t vnode -f efiboot.img`
+	newfs_msdos -F 12 -m 0xf8 /dev/$device
+	mkdir efi
+	mount -t msdosfs /dev/$device efi
+	mkdir -p efi/efi/boot
+	cp ${4}/boot/loader.efi efi/efi/boot/bootx64.efi
+	umount efi
+	rmdir efi
+	mdconfig -d -u $device
+	bootable="-o bootimage=i386;efiboot.img -o no-emul-boot $bootable"
+	
+	shift
+else
+	bootable=""
+fi
+
+if [ $# -lt 3 ]; then
+	echo Usage: $0 '[-b] image-label image-name base-bits-dir [extra-bits-dir]'
+	exit 1
+fi
+
+LABEL=`echo $1 | tr '[:lower:]' '[:upper:]'`; shift
+NAME=$1; shift
+
+publisher="The FreeBSD Project.  http://www.FreeBSD.org/"
+echo "/dev/iso9660/$LABEL / cd9660 ro 0 0" > $1/etc/fstab
+makefs -t cd9660 $bootable -o rockridge -o label=$LABEL -o publisher="$publisher" $NAME $*
+rm $1/etc/fstab
+rm -f efiboot.img


More information about the svn-src-head mailing list